using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls;

namespace RadToolStripDrop
{
    public partial class Form1 : Form
    {
        string buttonText = "";
        bool stopSearch = false;
        RadTreeNode nodeToDelete;

        public Form1()
        {
            InitializeComponent();

            this.radTreeView1.DragEnded += new Telerik.WinControls.UI.RadTreeView.DragEndedHandler(radTreeView1_DragEnded);
            this.radTreeView1.DragStarted += new Telerik.WinControls.UI.RadTreeView.DragStartedHandler(radTreeView1_DragStarted);
            this.radTreeView1.AllowDragDrop = true;
        }

        void radTreeView1_DragStarted(object sender, Telerik.WinControls.UI.RadTreeViewDragEventArgs e)
        {
            buttonText = e.Node.Text;
            nodeToDelete = e.Node as RadTreeNode;
        }

        void radTreeView1_DragEnded(object sender, Telerik.WinControls.UI.RadTreeViewDragEventArgs e)
        {
            Point clientCoords = this.PointToClient(new Point(Cursor.Position.X, Cursor.Position.Y));
            Control ctrl = this.GetChildAtPoint(clientCoords);
            RadToolStrip toolStrip = ctrl as RadToolStrip;
            if (toolStrip != null)
            {
                Point pt = toolStrip.PointToClient(new Point(Cursor.Position.X, Cursor.Position.Y));
                RadElement element = toolStrip.ElementTree.GetElementAtPoint(pt);
                if (element is RadButtonElement)
                {
                    RadToolStripItem item = element.Parent.Parent as RadToolStripItem;
                    RadButtonElement button = new RadButtonElement();
                    button.Text = buttonText;
                    buttonText = "";
                    item.Items.Add(button);
                }
                else if (element is RadToolStripItem)
                {
                    RadToolStripItem item = element as RadToolStripItem;
                    RadButtonElement button = new RadButtonElement();
                    button.Text = buttonText;
                    buttonText = "";
                    item.Items.Add(button);
                }

                for (int i = 0; i < this.radTreeView1.Nodes.Count; i++)
                {
                    if (this.radTreeView1.Nodes[i] == nodeToDelete)
                    {
                        this.radTreeView1.Nodes.Remove(nodeToDelete);
                    }
                    else
                    {
                        TraverseNodes(this.radTreeView1.Nodes[i]);
                    }
                }
                stopSearch = false;
            }
        }

        private void TraverseNodes(RadTreeNode node)
        {
            if (node.Nodes.Contains(nodeToDelete))
            {
                node.Nodes.Remove(nodeToDelete);
                stopSearch = true;
            }
            else if (!stopSearch)
            {
                for (int j = 0; j < node.Nodes.Count; j++)
                {
                    TraverseNodes(node.Nodes[j]);
                }
            }
        }
    }
}